#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 9.0, 5.0, 1.0 }; /* ʒu@@@@@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx@@@@ */
static const GLfloat lightdim[] = { 0.2, 0.2, 0.2, 1.0 }; /* e̊gUˋx */
static const GLfloat lightblk[] = { 0.0, 0.0, 0.0, 1.0 }; /* e̋ʔˋx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x@@@@ */

/*
** eNX`
*/
#define TEXWIDTH  512                                     /* eNX`̕@@ */
#define TEXHEIGHT 512                                     /* eNX`̍@ */

/*
** 
*/
static void init(void)
{
  /* eNX`̊蓖 */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, TEXWIDTH, TEXHEIGHT, 0,
    GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, 0);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* ރ|S̃eNX`Wl̂qƃeNX`Ƃ̔rs悤ɂ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  
  /* q̒leNX`̒lȉȂ^i܂j */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);
  
  /* řʂPxlƂē */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_LUMINANCE);
  
  /* eNX`WɎ_Wnɂ镨̂̍Wlp */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

  /* eNX`Ŵ܂ (S, T, R, Q) Ɏg */
  static const GLdouble genfunc[][4] = {
    { 1.0, 0.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0, 0.0 },
    { 0.0, 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 0.0, 1.0 },
  };
  glTexGendv(GL_S, GL_EYE_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_EYE_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_EYE_PLANE, genfunc[2]);
  glTexGendv(GL_Q, GL_EYE_PLANE, genfunc[3]);

  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);

#if defined(WIN32)
  glMultTransposeMatrixd =
    (PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress("glMultTransposeMatrixd");
#endif
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

/* gbN{[p֐̐錾 */
#include "trackball.h"

/* V[`֐̐錾 */
#include "scene.h"

/* Aj[ṼTCN */
#define FRAMES 600

static void display(void)
{
  GLint viewport[4];       /* r[|[g̕ۑp@@@@ */
  GLdouble modelview[16];  /* fr[ϊs̕ۑp */
  GLdouble projection[16]; /* ϊs̕ۑp@@@@ */
  static int frame = 0;    /* t[̃JEg@@@@ */
  double t = (double)frame / (double)FRAMES; /* oߎԁ@ */

  if (++frame >= FRAMES) frame = 0;

  /*
  ** PXebvFfvXeNX`̍쐬
  */
  
  /* fvXobt@NA */
  glClear(GL_DEPTH_BUFFER_BIT);
  
  /* ݂̃r[|[gۑĂ */
  glGetIntegerv(GL_VIEWPORT, viewport);
  
  /* r[|[geNX`̃TCYɐݒ肷 */
  glViewport(0, 0, TEXWIDTH, TEXHEIGHT);
  
  /* ݂̓ϊsۑĂ */
  glGetDoublev(GL_PROJECTION_MATRIX, projection);
  
  /* ϊsPʍsɐݒ肷 */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  /* ʒu_ƂV[Ɏ܂悤fr[ϊsݒ肷 */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluPerspective(40.0, (GLdouble)TEXWIDTH / (GLdouble)TEXHEIGHT, 1.0, 20.0);
  gluLookAt(lightpos[0], lightpos[1], lightpos[2], 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  /* ݒ肵fr[ϊsۑĂ */
  glGetDoublev(GL_MODELVIEW_MATRIX, modelview);

  /* fvXobt@̓e擾̂Ńt[obt@ɂ͏܂Ȃ */
  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

  /* ĉAetsvȂ̂ŃCeBOItɂ */
  glDisable(GL_LIGHTING);

  /* fvXobt@ɂ͔wʂ̃|S̉sL^悤ɂ */
  glCullFace(GL_FRONT);

  /* V[`悷 */
  scene(t);

  /* fvXobt@̓eeNX`ɓ] */
  glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, TEXWIDTH, TEXHEIGHT);

  /* ʏ̕`̐ݒɖ߂ */
  glViewport(viewport[0], viewport[1], viewport[2], viewport[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadMatrixd(projection);
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glEnable(GL_LIGHTING);
  glCullFace(GL_BACK);
  
  /*
  ** QXebvFŜ̕`
  */
  
  /* t[obt@ƃfvXobt@NA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* _̈ʒuݒ肷î̕Ɉړj*/
  glTranslated(0.0, 0.0, -10.0);
  
  /* gbN{[̉]^ */
  glMultMatrixd(trackballRotation());
  
  /* ̈ʒuݒ肷 */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* eNX`ϊsݒ肷 */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* eNX`W [-1,1] ͈̔͂ [0,1] ͈̔͂Ɏ߂ */
  glTranslated(0.5, 0.5, 0.5);
  glScaled(0.5, 0.5, 0.5);
  
  /* eNX`̃fr[ϊsƓϊs̐ς */
  glMultMatrixd(modelview);
  
  /* ݂̃fr[ϊ̋tϊĂ */
  glMultTransposeMatrixd(trackballRotation());
  glTranslated(0.0, 0.0, 10.0);
  
  /* fr[ϊsɖ߂ */
  glMatrixMode(GL_MODELVIEW);
  
  /* eNX`}bsOƃeNX`W̎Lɂ */
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_GEN_Q);
  
  /* ̖邳̕ł̖邳ɐݒ */
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  
  /* V[`悷 */
  scene(t);
  
  /* eNX`}bsOƃeNX`W̎𖳌ɂ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_GEN_Q);
  glDisable(GL_TEXTURE_2D);
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* EBhETCY̏k𐧌 */
  if (w < TEXWIDTH || h < TEXHEIGHT) {
    if (w < TEXWIDTH) w = TEXWIDTH;
    if (h < TEXHEIGHT) h = TEXHEIGHT;
    glutReshapeWindow(w, h);
  }

  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(40.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitWindowSize(TEXWIDTH, TEXHEIGHT);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);
  init();
  glutMainLoop();
  return 0;
}